Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.146.2.3
retrieving revision 1.146.2.4
diff -u -r1.146.2.3 -r1.146.2.4
--- squid/src/protos.h	27 Sep 2007 15:09:17 -0000	1.146.2.3
+++ squid/src/protos.h	27 Nov 2007 08:12:28 -0000	1.146.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.146.2.3 2007/09/27 15:09:17 adri Exp $
+ * $Id: protos.h,v 1.146.2.4 2007/11/27 08:12:28 adri Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -747,6 +747,10 @@
 extern void redirectInit(void);
 extern void redirectShutdown(void);
 
+extern void storeurlStart(clientHttpRequest *, RH *, void *);
+extern void storeurlInit(void);
+extern void storeurlShutdown(void);
+
 extern void locationRewriteStart(HttpReply *, clientHttpRequest *, RH *, void *);
 extern void locationRewriteInit(void);
 extern void locationRewriteShutdown(void);
@@ -796,9 +800,11 @@
 extern int refreshIsCachable(const StoreEntry *);
 extern int refreshCheckHTTP(const StoreEntry *, request_t *);
 extern int refreshCheckHTTPStale(const StoreEntry *, request_t *);
+extern int refreshCheckStaleOK(const StoreEntry *, request_t *);
 extern int refreshCheckICP(const StoreEntry *, request_t *);
 extern int refreshCheckHTCP(const StoreEntry *, request_t *);
 extern int refreshCheckDigest(const StoreEntry *, time_t delta);
+extern refresh_cc refreshCC(const StoreEntry *, request_t *);
 extern time_t getMaxAge(const char *url);
 extern void refreshInit(void);
 extern const refresh_t *refreshLimits(const char *url);
@@ -911,6 +917,7 @@
  * store.c
  */
 extern StoreEntry *new_StoreEntry(int, const char *);
+extern void storeEntrySetStoreUrl(StoreEntry * e, const char *store_url);
 extern StoreEntry *storeGet(const cache_key *);
 extern StoreEntry *storeGetPublic(const char *uri, const method_t method);
 extern StoreEntry *storeGetPublicByRequest(request_t * request);
@@ -924,6 +931,7 @@
 extern void storeLockObjectDebug(StoreEntry *, const char *file, const int line);
 extern void storeRelease(StoreEntry *);
 extern int storeUnlockObjectDebug(StoreEntry *, const char *file, const int line);
+extern const char *storeLookupUrl(const StoreEntry * e);
 #define	storeLockObject(a) storeLockObjectDebug(a, __FILE__, __LINE__);
 #define	storeUnlockObject(a) storeUnlockObjectDebug(a, __FILE__, __LINE__);
 extern EVH storeMaintainSwapSpace;
@@ -970,6 +978,7 @@
 void storeResumeRead(StoreEntry *);
 void storeResetDefer(StoreEntry *);
 extern int memHaveHeaders(const MemObject * mem);
+extern void storeUpdate(StoreEntry * e, request_t *);
 
 
 /* store_modules.c */
@@ -1091,6 +1100,7 @@
 extern store_client *storeClientRegister(StoreEntry * e, void *data);
 extern void storeClientCopy(store_client *, StoreEntry *, squid_off_t, squid_off_t, size_t, char *, STCB *, void *);
 extern void storeClientRef(store_client *, StoreEntry *, squid_off_t, squid_off_t, size_t, STNCB *, void *);
+extern void storeClientCopyHeaders(store_client *, StoreEntry *, STHCB *, void *);
 extern int storeClientCopyPending(store_client *, StoreEntry * e, void *data);
 extern int storeClientUnregister(store_client * sc, StoreEntry * e, void *data);
 extern squid_off_t storeLowestMemReaderOffset(const StoreEntry * entry);
@@ -1415,6 +1425,15 @@
 const char *externalAclMessage(external_acl_entry * entry);
 
 
+/* refresh_check.c */
+extern void parse_refreshCheckHelper(refresh_check_helper **);
+extern void dump_refreshCheckHelper(StoreEntry * sentry, const char *name, const refresh_check_helper *);
+extern void free_refreshCheckHelper(refresh_check_helper **);
+extern void refreshCheckSubmit(StoreEntry * entry, REFRESHCHECK * callback, void *data);
+extern void refreshCheckInit(void);
+extern void refreshCheckConfigure(void);
+extern void refreshCheckShutdown(void);
+
 #if USE_WCCPv2
 extern void parse_wccp2_service(void *v);
 extern void free_wccp2_service(void *v);
@@ -1448,5 +1467,20 @@
 
 extern const char *xinet_ntoa(const struct in_addr addr);
 
+/* client_side.c */
+extern aclCheck_t *clientAclChecklistCreate(const acl_access * acl, const clientHttpRequest * http);
+extern void clientInterpretRequestHeaders(clientHttpRequest * http);
+extern void clientAccessCheck2(void *data);
+
+/* client_side_redirect.c */
+extern void clientRedirectAccessCheckDone(int answer, void *data);
+extern void clientRedirectStart(clientHttpRequest * http);
+extern void clientRedirectDone(void *data, char *result);
+
+/* client_side_storeurl_rewrite.c */
+extern void clientStoreURLRewriteAccessCheckDone(int answer, void *data);
+extern void clientStoreURLRewriteStart(clientHttpRequest * http);
+extern void clientStoreURLRewriteDone(void *data, char *result);
+
 
 #endif /* SQUID_PROTOS_H */
Index: squid/src/redirect.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/redirect.c,v
retrieving revision 1.16
retrieving revision 1.16.10.1
diff -u -r1.16 -r1.16.10.1
--- squid/src/redirect.c	1 Feb 2007 09:51:50 -0000	1.16
+++ squid/src/redirect.c	27 Nov 2007 08:12:28 -0000	1.16.10.1
@@ -1,9 +1,9 @@
 
 /*
- * $Id: redirect.c,v 1.16 2007/02/01 09:51:50 squidadm Exp $
+ * $Id: redirect.c,v 1.16.10.1 2007/11/27 08:12:28 adri Exp $
  *
- * DEBUG: section 61    Redirector
- * AUTHOR: Duane Wessels
+ * DEBUG: section 85   Store URL Redirector
+ * AUTHOR: Adrian Chadd; based on redirect.c by Duane Wessels
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
  * ----------------------------------------------------------
@@ -98,6 +98,8 @@
     const char *fqdn;
     char *urlgroup = conn->port->urlgroup;
     char buf[8192];
+    char claddr[20];
+    char myaddr[20];
     assert(http);
     assert(handler);
     debug(61, 5) ("redirectStart: '%s'\n", http->uri);
@@ -130,13 +132,17 @@
     cbdataLock(r->data);
     if ((fqdn = fqdncache_gethostbyaddr(r->client_addr, 0)) == NULL)
 	fqdn = dash_str;
-    snprintf(buf, 8191, "%s %s/%s %s %s %s",
+    xstrncpy(claddr, inet_ntoa(r->client_addr), 20);
+    xstrncpy(myaddr, inet_ntoa(http->request->my_addr), 20);
+    snprintf(buf, 8191, "%s %s/%s %s %s %s myip=%s myport=%d",
 	r->orig_url,
-	inet_ntoa(r->client_addr),
+	claddr,
 	fqdn,
 	r->client_ident[0] ? rfc1738_escape(r->client_ident) : dash_str,
 	r->method_s,
-	urlgroup ? urlgroup : "-");
+	urlgroup ? urlgroup : "-",
+	myaddr,
+	http->request->my_port);
     debug(61, 6) ("redirectStart: sending '%s' to the helper\n", buf);
     strcat(buf, "\n");
     helperSubmit(redirectors, buf, redirectHandleReply, r);
Index: squid/src/refresh.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/refresh.c,v
retrieving revision 1.15
retrieving revision 1.15.6.1
diff -u -r1.15 -r1.15.6.1
--- squid/src/refresh.c	24 May 2007 01:51:31 -0000	1.15
+++ squid/src/refresh.c	27 Nov 2007 08:12:28 -0000	1.15.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: refresh.c,v 1.15 2007/05/24 01:51:31 squidadm Exp $
+ * $Id: refresh.c,v 1.15.6.1 2007/11/27 08:12:28 adri Exp $
  *
  * DEBUG: section 22    Refresh Calculation
  * AUTHOR: Harvest Derived
@@ -81,6 +81,8 @@
     STALE_MAX_RULE,
     STALE_LMFACTOR_RULE,
     STALE_WITHIN_DELTA,
+    STALE_ASYNC_REFRESH,
+    STALE_MAX_STALE,
     STALE_DEFAULT = 299
 };
 
@@ -128,6 +130,30 @@
     return NULL;
 }
 
+refresh_cc
+refreshCC(const StoreEntry * entry, request_t * request)
+{
+    const refresh_t *R;
+    const char *uri = NULL;
+    refresh_cc cc;
+    cc.negative_ttl = Config.negativeTtl;
+    cc.max_stale = Config.maxStale;
+    if (entry->mem_obj)
+	uri = entry->mem_obj->url;
+    else if (request)
+	uri = urlCanonical(request);
+
+    R = uri ? refreshLimits(uri) : refreshUncompiledPattern(".");
+
+    if (R && R->negative_ttl >= 0)
+	cc.negative_ttl = R->negative_ttl;
+
+    if (R && R->max_stale >= 0)
+	cc.max_stale = R->max_stale;
+
+    return cc;
+}
+
 /*
  * Calculate how stale the response is (or will be at the check_time).
  * Staleness calculation is based on the following: (1) response
@@ -308,6 +334,20 @@
      * At this point the response is stale, unless one of
      * the override options kicks in.
      */
+    if (entry->mem_obj) {
+	int stale_while_revalidate = R->stale_while_revalidate;
+	if (staleness < stale_while_revalidate) {
+	    debug(22, 3) ("stale-while-revalidate: age=%d, staleness=%d, stale_while_revalidate=%d\n", (int) age, staleness, stale_while_revalidate);
+	    entry->mem_obj->stale_while_revalidate = stale_while_revalidate;
+	    return STALE_ASYNC_REFRESH;
+	}
+    } {
+	int max_stale = Config.maxStale;
+	if (R->max_stale >= 0)
+	    max_stale = R->max_stale;
+	if (max_stale >= 0 && staleness >= max_stale)
+	    return STALE_MAX_STALE;
+    }
     if (delta < 0 && staleness + delta < 0) {
 	return STALE_WITHIN_DELTA;
     }
@@ -382,10 +422,25 @@
     int reason = refreshCheck(entry, request, -Config.refresh_stale_window);
     if (reason == STALE_WITHIN_DELTA)
 	return -1;
+    if (reason == STALE_ASYNC_REFRESH)
+	return -2;
+    if (reason == STALE_MAX_STALE)
+	return 3;
     return (reason < 200) ? 0 : 1;
 }
 
 int
+refreshCheckStaleOK(const StoreEntry * entry, request_t * request)
+{
+    int reason = refreshCheck(entry, request, 0);
+    if (reason == STALE_MUST_REVALIDATE)
+	return 0;
+    if (reason == STALE_MAX_STALE)
+	return 0;
+    return 1;
+}
+
+int
 refreshCheckICP(const StoreEntry * entry, request_t * request)
 {
     int reason = refreshCheck(entry, request, 30);
@@ -472,6 +527,12 @@
 	"Stale: refresh_pattern max age rule");
     refreshCountsStatsEntry(STALE_LMFACTOR_RULE,
 	"Stale: refresh_pattern last-mod factor percentage");
+    refreshCountsStatsEntry(STALE_WITHIN_DELTA,
+	"Staĺe: but within a certain delta");
+    refreshCountsStatsEntry(STALE_ASYNC_REFRESH,
+	"Stale: suitable for an async refresh");
+    refreshCountsStatsEntry(STALE_MAX_STALE,
+	"Stale: max-stale");
     refreshCountsStatsEntry(STALE_DEFAULT,
 	"Stale: by default");
 
--- /dev/null	Wed Nov 28 01:20:24 2007
+++ squid/src/refresh_check.c	Wed Nov 28 01:20:25 2007
@@ -0,0 +1,550 @@
+
+/*
+ * $Id: refresh_check.c,v 1.2.4.2 2007/11/27 08:12:28 adri Exp $
+ *
+ * DEBUG: section 84    Refresh Check Helper
+ * AUTHOR: Henrik Nordstrom
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  The contents of this file is Copyright (C) 2007 by Henrik Nordstrom,
+ *  Sweden, unless otherwise is indicated in the specific function. The
+ *  author gives his full permission to include this file into the Squid
+ *  software product under the terms of the GNU General Public License as
+ *  published by the Free Software Foundation; either version 2 of the
+ *  License, or (at your option) any later version.
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ * Partially based on the External ACL implementation.
+ */
+
+#include "squid.h"
+
+#ifndef DEFAULT_REFRESH_CHECK_CHILDREN
+#define DEFAULT_REFRESH_CHECK_CHILDREN 5
+#endif
+
+/******************************************************************
+ * external_refresh_check parser
+ */
+typedef struct _refresh_check_format refresh_check_format;
+
+struct _refresh_check_helper {
+    refresh_check_format *format;
+    wordlist *cmdline;
+    int children;
+    int concurrency;
+    helper *helper;
+    dlink_list queue;
+};
+
+struct _refresh_check_format {
+    enum {
+	REFRESH_CHECK_UNKNOWN,
+	REFRESH_CHECK_URI,
+	REFRESH_CHECK_RESP_HEADER,
+	REFRESH_CHECK_RESP_HEADER_MEMBER,
+	REFRESH_CHECK_RESP_HEADER_ID,
+	REFRESH_CHECK_RESP_HEADER_ID_MEMBER,
+	REFRESH_CHECK_AGE,
+	REFRESH_CHECK_END
+    } type;
+    refresh_check_format *next;
+    char *header;
+    char *member;
+    char separator;
+    http_hdr_type header_id;
+};
+
+/* FIXME: These are not really cbdata, but it is an easy way
+ * to get them pooled, refcounted, accounted and freed properly...
+ */
+CBDATA_TYPE(refresh_check_helper);
+CBDATA_TYPE(refresh_check_format);
+
+static void
+free_refresh_check_format(void *data)
+{
+    refresh_check_format *p = data;
+    safe_free(p->header);
+}
+
+static void
+free_refresh_check_helper(void *data)
+{
+    refresh_check_helper *p = data;
+    while (p->format) {
+	refresh_check_format *f = p->format;
+	p->format = f->next;
+	cbdataFree(f);
+    }
+    wordlistDestroy(&p->cmdline);
+    if (p->helper) {
+	helperShutdown(p->helper);
+	helperFree(p->helper);
+	p->helper = NULL;
+    }
+}
+
+void
+parse_refreshCheckHelper(refresh_check_helper ** ptr)
+{
+    refresh_check_helper *a;
+    char *token;
+    refresh_check_format **p;
+
+    if (*ptr)
+	self_destruct();
+
+    CBDATA_INIT_TYPE_FREECB(refresh_check_helper, free_refresh_check_helper);
+    CBDATA_INIT_TYPE_FREECB(refresh_check_format, free_refresh_check_format);
+
+    a = cbdataAlloc(refresh_check_helper);
+
+    a->children = DEFAULT_REFRESH_CHECK_CHILDREN;
+
+    /* Parse options */
+    while ((token = strtok(NULL, w_space)) != NULL) {
+	if (strncmp(token, "children=", 9) == 0) {
+	    a->children = atoi(token + 9);
+	} else if (strncmp(token, "concurrency=", 12) == 0) {
+	    a->concurrency = atoi(token + 12);
+	} else {
+	    break;
+	}
+    }
+
+    /* Parse format */
+    p = &a->format;
+    while (token) {
+	refresh_check_format *format;
+
+	/* stop on first non-format token found */
+	if (*token != '%')
+	    break;
+
+	format = cbdataAlloc(refresh_check_format);
+
+	if (strncmp(token, "%RES{", 5) == 0) {
+	    /* header format */
+	    char *header, *member, *end;
+	    header = token + 5;
+	    end = strchr(header, '}');
+	    /* cut away the terminating } */
+	    if (end && strlen(end) == 1)
+		*end = '\0';
+	    else
+		self_destruct();
+
+	    member = strchr(header, ':');
+	    if (member) {
+		/* Split in header and member */
+		*member++ = '\0';
+		if (!xisalnum(*member))
+		    format->separator = *member++;
+		else
+		    format->separator = ',';
+		format->member = xstrdup(member);
+		format->type = REFRESH_CHECK_RESP_HEADER_MEMBER;
+	    } else {
+		format->type = REFRESH_CHECK_RESP_HEADER;
+	    }
+	    format->header = xstrdup(header);
+	    format->header_id = httpHeaderIdByNameDef(header, strlen(header));
+	    if (format->header_id != -1) {
+		if (member)
+		    format->type = REFRESH_CHECK_RESP_HEADER_ID_MEMBER;
+		else
+		    format->type = REFRESH_CHECK_RESP_HEADER_ID;
+	    }
+	} else if (strcmp(token, "%URI") == 0)
+	    format->type = REFRESH_CHECK_URI;
+	else if (strcmp(token, "%URL") == 0)
+	    format->type = REFRESH_CHECK_URI;
+	else if (strcmp(token, "%CACHE_URI") == 0)
+	    format->type = REFRESH_CHECK_URI;
+	else if (strcmp(token, "%AGE") == 0)
+	    format->type = REFRESH_CHECK_AGE;
+	else {
+	    self_destruct();
+	}
+	*p = format;
+	p = &format->next;
+	token = strtok(NULL, w_space);
+    }
+    /* There must be at least one format token */
+    if (!a->format)
+	self_destruct();
+
+    /* helper */
+    if (!token)
+	self_destruct();
+    wordlistAdd(&a->cmdline, token);
+
+    /* arguments */
+    parse_wordlist(&a->cmdline);
+
+    *ptr = a;
+}
+
+void
+dump_refreshCheckHelper(StoreEntry * sentry, const char *name, const refresh_check_helper * list)
+{
+    const refresh_check_helper *node = list;
+    const refresh_check_format *format;
+    const wordlist *word;
+    if (node) {
+	storeAppendPrintf(sentry, "%s", name);
+	if (node->children != DEFAULT_REFRESH_CHECK_CHILDREN)
+	    storeAppendPrintf(sentry, " children=%d", node->children);
+	if (node->concurrency)
+	    storeAppendPrintf(sentry, " concurrency=%d", node->concurrency);
+	for (format = node->format; format; format = format->next) {
+	    switch (format->type) {
+	    case REFRESH_CHECK_RESP_HEADER:
+	    case REFRESH_CHECK_RESP_HEADER_ID:
+		storeAppendPrintf(sentry, " %%{%s}", format->header);
+		break;
+	    case REFRESH_CHECK_RESP_HEADER_MEMBER:
+	    case REFRESH_CHECK_RESP_HEADER_ID_MEMBER:
+		storeAppendPrintf(sentry, " %%{%s:%s}", format->header, format->member);
+		break;
+#define DUMP_REFRESH_CHECK_TYPE(a) \
+	    case REFRESH_CHECK_##a: \
+		storeAppendPrintf(sentry, " %%%s", #a); \
+		break
+		DUMP_REFRESH_CHECK_TYPE(URI);
+		DUMP_REFRESH_CHECK_TYPE(AGE);
+	    case REFRESH_CHECK_UNKNOWN:
+	    case REFRESH_CHECK_END:
+		fatal("unknown refresh_check format error");
+		break;
+	    }
+	}
+	for (word = node->cmdline; word; word = word->next)
+	    storeAppendPrintf(sentry, " %s", word->key);
+	storeAppendPrintf(sentry, "\n");
+    }
+}
+
+void
+free_refreshCheckHelper(refresh_check_helper ** list)
+{
+    while (*list) {
+	refresh_check_helper *node = *list;
+	*list = NULL;
+	cbdataFree(node);
+    }
+}
+
+/******************************************************************
+ * refresh_check runtime
+ */
+
+static inline int
+refreshCheckOverload(refresh_check_helper * def)
+{
+    return def->helper->stats.queue_size > def->helper->n_running;
+}
+
+static char *
+makeRefreshCheckRequest(StoreEntry * entry, refresh_check_format * format)
+{
+    static MemBuf mb = MemBufNULL;
+    int first = 1;
+    HttpReply *reply;
+    String sb = StringNull;
+
+    if (!entry->mem_obj)
+	return NULL;
+
+    reply = entry->mem_obj->reply;
+    memBufReset(&mb);
+    for (; format; format = format->next) {
+	char buf[256];
+	const char *str = NULL;
+	const char *quoted;
+	switch (format->type) {
+	case REFRESH_CHECK_URI:
+	    str = entry->mem_obj->url;
+	    break;
+	case REFRESH_CHECK_AGE:
+	    snprintf(buf, sizeof(buf), "%ld", (long int) (squid_curtime - entry->timestamp));
+	    str = buf;
+	    break;
+	case REFRESH_CHECK_RESP_HEADER:
+	    sb = httpHeaderGetByName(&reply->header, format->header);
+	    str = strBuf(sb);
+	    break;
+	case REFRESH_CHECK_RESP_HEADER_ID:
+	    sb = httpHeaderGetStrOrList(&reply->header, format->header_id);
+	    str = strBuf(sb);
+	    break;
+	case REFRESH_CHECK_RESP_HEADER_MEMBER:
+	    sb = httpHeaderGetByNameListMember(&reply->header, format->header, format->member, format->separator);
+	    str = strBuf(sb);
+	    break;
+	case REFRESH_CHECK_RESP_HEADER_ID_MEMBER:
+	    sb = httpHeaderGetListMember(&reply->header, format->header_id, format->member, format->separator);
+	    str = strBuf(sb);
+	    break;
+
+	case REFRESH_CHECK_UNKNOWN:
+	case REFRESH_CHECK_END:
+	    fatal("unknown refresh_check_program format error");
+	    break;
+	}
+	if (!str || !*str)
+	    str = "-";
+	if (!first)
+	    memBufAppend(&mb, " ", 1);
+	quoted = rfc1738_escape(str);
+	memBufAppend(&mb, quoted, strlen(quoted));
+	stringClean(&sb);
+	first = 0;
+    }
+    return mb.buf;
+}
+
+/******************************************************************
+ * refresh_check requests
+ */
+
+typedef struct _refreshCheckState refreshCheckState;
+struct _refreshCheckState {
+    REFRESHCHECK *callback;
+    void *callback_data;
+    StoreEntry *entry;
+    refresh_check_helper *def;
+    dlink_node list;
+    refreshCheckState *queue;
+};
+
+CBDATA_TYPE(refreshCheckState);
+static void
+free_refreshCheckState(void *data)
+{
+    refreshCheckState *state = data;
+    storeUnlockObject(state->entry);
+    cbdataUnlock(state->callback_data);
+    cbdataUnlock(state->def);
+}
+
+/*
+ * The helper program receives queries on stdin, one
+ * per line, and must return the result on on stdout
+ */
+static void
+refreshCheckHandleReply(void *data, char *reply)
+{
+    refreshCheckState *state = data;
+    refreshCheckState *next;
+    int freshness = -1;
+    char *log = NULL;
+    MemBuf hdrs = MemBufNULL;
+
+
+    debug(84, 2) ("refreshCheckHandleReply: reply=\"%s\"\n", reply);
+
+    if (reply) {
+	char *t = NULL;
+	char *token = strwordtok(reply, &t);
+	if (token && strcmp(token, "FRESH") == 0)
+	    freshness = 0;
+	else if (token && strcmp(token, "OK") == 0)
+	    freshness = 0;
+
+	while ((token = strwordtok(NULL, &t))) {
+	    char *value = strchr(token, '=');
+	    if (value) {
+		*value++ = '\0';	/* terminate the token, and move up to the value */
+		rfc1738_unescape(value);
+		if (strcmp(token, "freshness") == 0)
+		    freshness = atoi(value);
+		else if (strcmp(token, "log") == 0)
+		    log = value;
+		else if (strncmp(token, "res{", 4) == 0) {
+		    char *header, *t;
+		    header = token + 4;
+		    t = strrchr(header, '}');
+		    if (!t)
+			continue;
+		    *t = '\0';
+		    if (!hdrs.buf)
+			memBufDefInit(&hdrs);
+		    memBufPrintf(&hdrs, "%s: %s\r\n", header, value);
+		}
+	    }
+	}
+    }
+    if (freshness >= 0) {
+	if (hdrs.size) {
+	    HttpReply *rep = httpReplyCreate();
+	    httpHeaderParse(&rep->header, hdrs.buf, hdrs.buf + hdrs.size);
+	    httpReplyUpdateOnNotModified(state->entry->mem_obj->reply, rep);
+	    storeTimestampsSet(state->entry);
+	    if (!httpHeaderHas(&rep->header, HDR_DATE)) {
+		state->entry->timestamp = squid_curtime;
+		state->entry->expires = squid_curtime + freshness;
+	    } else if (freshness) {
+		state->entry->expires = squid_curtime + freshness;
+	    }
+	    httpReplyDestroy(rep);
+	    storeUpdate(state->entry, NULL);
+	} else {
+	    state->entry->timestamp = squid_curtime;
+	    state->entry->expires = squid_curtime + freshness;
+	}
+    }
+    if (hdrs.buf)
+	memBufClean(&hdrs);
+    dlinkDelete(&state->list, &state->def->queue);
+    do {
+	cbdataUnlock(state->def);
+	state->def = NULL;
+
+	if (state->callback && cbdataValid(state->callback_data))
+	    state->callback(state->callback_data, freshness >= 0, log);
+	cbdataUnlock(state->callback_data);
+	state->callback_data = NULL;
+
+	next = state->queue;
+	cbdataFree(state);
+	state = next;
+    } while (state);
+}
+
+void
+refreshCheckSubmit(StoreEntry * entry, REFRESHCHECK * callback, void *callback_data)
+{
+    MemBuf buf;
+    const char *key;
+    refresh_check_helper *def = Config.Program.refresh_check;
+    refreshCheckState *state;
+    dlink_node *node;
+    refreshCheckState *oldstate = NULL;
+
+    if (!def) {
+	callback(callback_data, 0, NULL);
+	return;
+    }
+    key = makeRefreshCheckRequest(entry, def->format);
+    if (!key) {
+	callback(callback_data, 0, NULL);
+	return;
+    }
+    debug(84, 2) ("refreshCheckLookup: for '%s'\n", key);
+
+    /* Check for a pending lookup to hook into */
+    for (node = def->queue.head; node; node = node->next) {
+	refreshCheckState *oldstatetmp = node->data;
+	if (entry == oldstatetmp->entry) {
+	    oldstate = oldstatetmp;
+	    break;
+	}
+    }
+
+    state = cbdataAlloc(refreshCheckState);
+    state->def = def;
+    cbdataLock(state->def);
+    state->entry = entry;
+    storeLockObject(entry);
+    state->callback = callback;
+    state->callback_data = callback_data;
+    cbdataLock(state->callback_data);
+    if (oldstate) {
+	/* Hook into pending lookup */
+	state->queue = oldstate->queue;
+	oldstate->queue = state;
+    } else {
+	/* No pending lookup found. Sumbit to helper */
+	/* Check for queue overload */
+	if (refreshCheckOverload(def)) {
+	    debug(84, 1) ("refreshCheckLookup: queue overload\n");
+	    cbdataFree(state);
+	    callback(callback_data, 0, "Overload");
+	    return;
+	}
+	/* Send it off to the helper */
+	memBufDefInit(&buf);
+	memBufPrintf(&buf, "%s\n", key);
+	helperSubmit(def->helper, buf.buf, refreshCheckHandleReply, state);
+	dlinkAdd(state, &state->list, &def->queue);
+	memBufClean(&buf);
+    }
+}
+
+static void
+refreshCheckStats(StoreEntry * sentry)
+{
+    refresh_check_helper *p = Config.Program.refresh_check;
+
+    if (p) {
+	storeAppendPrintf(sentry, "Refresh Check helper statistics:\n");
+	helperStats(sentry, p->helper);
+	storeAppendPrintf(sentry, "\n");
+    }
+}
+void
+refreshCheckConfigure(void)
+{
+    refresh_check_helper *p = Config.Program.refresh_check;
+    if (p) {
+	requirePathnameExists("external_refresh_check", p->cmdline->key);
+    }
+}
+void
+refreshCheckInit(void)
+{
+    static int firstTimeInit = 1;
+    refresh_check_helper *p = Config.Program.refresh_check;
+
+    if (p) {
+	if (!p->helper)
+	    p->helper = helperCreate("external_refresh_check");
+	p->helper->cmdline = p->cmdline;
+	p->helper->n_to_start = p->children;
+	p->helper->concurrency = p->concurrency;
+	p->helper->ipc_type = IPC_STREAM;
+	helperOpenServers(p->helper);
+	if (firstTimeInit) {
+	    firstTimeInit = 0;
+	    cachemgrRegister("refresh_check",
+		"External ACL stats",
+		refreshCheckStats, 0, 1);
+	}
+	CBDATA_INIT_TYPE_FREECB(refreshCheckState, free_refreshCheckState);
+    }
+}
+
+void
+refreshCheckShutdown(void)
+{
+    refresh_check_helper *p = Config.Program.refresh_check;
+    if (p) {
+	helperShutdown(p->helper);
+    }
+}
Index: squid/src/stat.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/stat.c,v
retrieving revision 1.42.2.2
retrieving revision 1.42.2.3
diff -u -r1.42.2.2 -r1.42.2.3
--- squid/src/stat.c	26 Sep 2007 07:33:50 -0000	1.42.2.2
+++ squid/src/stat.c	27 Nov 2007 08:12:28 -0000	1.42.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: stat.c,v 1.42.2.2 2007/09/26 07:33:50 adri Exp $
+ * $Id: stat.c,v 1.42.2.3 2007/11/27 08:12:28 adri Exp $
  *
  * DEBUG: section 18    Cache Manager Statistics
  * AUTHOR: Harvest Derived
@@ -204,8 +204,8 @@
 	strcat(buf, "DELAY_SENDING,");
     if (EBIT_TEST(flags, RELEASE_REQUEST))
 	strcat(buf, "RELEASE_REQUEST,");
-    if (EBIT_TEST(flags, REFRESH_REQUEST))
-	strcat(buf, "REFRESH_REQUEST,");
+    if (EBIT_TEST(flags, REFRESH_FAILURE))
+	strcat(buf, "REFRESH_FAILURE,");
     if (EBIT_TEST(flags, ENTRY_CACHABLE))
 	strcat(buf, "CACHABLE,");
     if (EBIT_TEST(flags, ENTRY_DISPATCHED))
@@ -251,6 +251,8 @@
     if (mem)
 	memBufPrintf(mb, "\t%s %s\n",
 	    RequestMethods[mem->method].str, mem->url);
+    if (mem && mem->store_url)
+	memBufPrintf(mb, "\tStore lookup URL: %s\n", mem->store_url);
     memBufPrintf(mb, "\t%s\n", describeStatuses(e));
     memBufPrintf(mb, "\t%s\n", storeEntryFlags(e));
     memBufPrintf(mb, "\t%s\n", describeTimestamps(e));
@@ -421,7 +423,15 @@
     LOCAL_ARRAY(char, buf, 32);
     if (f->type != FD_SOCKET)
 	return null_string;
-    snprintf(buf, 32, "%s.%d", f->ipaddr, (int) f->remote_port);
+    if (*f->ipaddr)
+	snprintf(buf, 32, "%s.%d", f->ipaddr, (int) f->remote_port);
+    else {
+	if (f->local_addr.s_addr != any_addr.s_addr) {
+	    snprintf(buf, 32, "%s.%d", inet_ntoa(f->local_addr), (int) f->local_port);
+	} else {
+	    snprintf(buf, 32, "*.%d", (int) f->local_port);
+	}
+    }
     return buf;
 }
 
